' Fname.VBS V1.01 (C) yoshioka.teruo@nifty.com 2005-02-08
' Fname.VBS renames file to "yyyymmdd title.ext".
' Usage: start Fname.VBS files...

Option Explicit
Dim fso
Dim arg
Dim Shell
Dim ext
Dim File
Dim ModDate
Dim Folder
Dim FolderItem
Dim Title
Dim Subject
Dim Author
Dim Category
Dim Comments
Dim ans
Dim n
Dim name

Set fso=CreateObject("Scripting.FileSystemObject")
Set Shell=CreateObject("Shell.Application")

For Each arg In WScript.Arguments
  Set File=fso.GetFile(arg)
  ModDate=File.DateLastModified
  ext=fso.GetExtensionName(File.Name)
  Set Folder=Shell.NameSpace(File.ParentFolder.Path)
  Set FolderItem=Folder.ParseName(File.Name)
  Title=FolderItem.ExtendedProperty("DocTitle")
  Subject=FolderItem.ExtendedProperty("DocSubject")
  Author=FolderItem.ExtendedProperty("DocAuthor")
  Category=FolderItem.ExtendedProperty("DocCategory")
  Comments=FolderItem.ExtendedProperty("DocComments")
  Set Folder=Nothing
  Set FolderItem=Nothing
  ModDate=CStr(Year(ModDate)*10000+Month(ModDate)*100+Day(ModDate))&Space(1)
'  ModDate=""
  ans=1
  Do While ans<>"" And IsNumeric(ans)
    Select Case CLng(ans)
    Case 1 name=Title
    Case 2 name=Subject
    Case 3 name=Author
    Case 4 name=Category
    Case 5 name=Comments
    End Select
    If name<>"" Then
      name=Replace(name,"\","")
      name=Replace(name,"/","^")
      name=Replace(name,":","F")
      name=Replace(name,"*","")
      name=Replace(name,"?","H")
      name=Replace(name,"""","h")
      name=Replace(name,"<","")
      name=Replace(name,">","")
      name=Replace(name,"|","b")
    End If
    ans=ModDate & name & "." & ext
    ans=InputBox("1.Title   :"&Title&vbCrLf&_
                 "2.Subject :"&Subject&vbCrLf&_
                 "3.Author  :"&Author&vbCrLf&_
                 "4.Category:"&Category&vbCrLf&_
                 "5.Comments:"&Comments&vbCrLf&_
                 "# Enter New Name or #",File.Name,ans)
  Loop
  n=1
  Do While ans<>""
    Call Rename(File,ans)
    If Err=0 Then
      ans=""
    ElseIf Err=58 Then
      n=n+1
      ans=ModDate & name & " " & n & "." & ext
      ans=InputBox(Err.Number & ":" & Err.Description & "Re-Enter New Name",File.Name,ans)
    Else
      ans=InputBox(Err.Number & ":" & Err.Description & "Re-Enter New Name",File.Name,ans)
    End If
  Loop
Next
WScript.Quit

Sub Rename(File,name)
On Error Resume Next
File.Name=name
End Sub
